/**
 * POCDMT000040StructuredBody.java
 *
 * File generated from the cdaepsos3::POCDMT000040StructuredBody uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos4;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.ArrayList;
import java.util.List;

// End of user code


/**
 * Description of the class POCDMT000040StructuredBody.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.StructuredBody", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"confidentialityCode",
	"languageCode",
	"component",
	"classCode",
	"moodCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.StructuredBody")
public class POCDMT000040StructuredBody implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "confidentialityCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE confidentialityCode;
	@XmlElement(name = "languageCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CS languageCode;
	@XmlElement(name = "component", required = true, namespace = "urn:hl7-org:v3")
	public List<POCDMT000040Component3> component;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.ActClass classCode;
	@XmlAttribute(name = "moodCode")
	public net.ihe.gazelle.voc.ActMood moodCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	@XmlTransient
	private Object __parent;
	
	void afterUnmarshal( javax.xml.bind.Unmarshaller u, Object parent ){
		this.__parent = parent;
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return confidentialityCode.
	 * @return confidentialityCode
	 */
	public net.ihe.gazelle.datatypes.CE getConfidentialityCode() {
	    return confidentialityCode;
	}
	
	/**
	 * Set a value to attribute confidentialityCode.
	 * @param confidentialityCode.
	 */
	public void setConfidentialityCode(net.ihe.gazelle.datatypes.CE confidentialityCode) {
	    this.confidentialityCode = confidentialityCode;
	}
	
	
	
	
	/**
	 * Return languageCode.
	 * @return languageCode
	 */
	public net.ihe.gazelle.datatypes.CS getLanguageCode() {
	    return languageCode;
	}
	
	/**
	 * Set a value to attribute languageCode.
	 * @param languageCode.
	 */
	public void setLanguageCode(net.ihe.gazelle.datatypes.CS languageCode) {
	    this.languageCode = languageCode;
	}
	
	
	
	
	/**
	 * Return component.
	 * @return component
	 */
	public List<POCDMT000040Component3> getComponent() {
		if (component == null) {
	        component = new ArrayList<POCDMT000040Component3>();
	    }
	    return component;
	}
	
	/**
	 * Set a value to attribute component.
	 * @param component.
	 */
	public void setComponent(List<POCDMT000040Component3> component) {
	    this.component = component;
	}
	
	
	
	/**
	 * Add a component to the component collection.
	 * @param component_elt Element to add.
	 */
	public void addComponent(POCDMT000040Component3 component_elt) {
	    this.getComponent().add(component_elt);
	}
	
	/**
	 * Remove a component to the component collection.
	 * @param component_elt Element to remove
	 */
	public void removeComponent(POCDMT000040Component3 component_elt) {
	    this.getComponent().remove(component_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.ActClass getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.ActClass classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return moodCode.
	 * @return moodCode
	 */
	public net.ihe.gazelle.voc.ActMood getMoodCode() {
	    return moodCode;
	}
	
	/**
	 * Set a value to attribute moodCode.
	 * @param moodCode.
	 */
	public void setMoodCode(net.ihe.gazelle.voc.ActMood moodCode) {
	    this.moodCode = moodCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	/**
	 * Return __parent.
	 * @return __parent
	 */
	public Object get__parent() {
	    return __parent;
	}
	
	/**
	 * Set a value to attribute __parent.
	 * @param __parent.
	 */
	public void set__parent(Object __parent) {
	    this.__parent = __parent;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos4");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.StructuredBody").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040StructuredBody pOCDMT000040StructuredBody, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040StructuredBody != null){
   			cvm.validate(pOCDMT000040StructuredBody, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040StructuredBody.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040StructuredBody.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040StructuredBody.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040StructuredBody.getConfidentialityCode(), _location + "/confidentialityCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CS.validateByModule(pOCDMT000040StructuredBody.getLanguageCode(), _location + "/languageCode", cvm, diagnostic);
			{
				int i = 0;
				for (POCDMT000040Component3 component: pOCDMT000040StructuredBody.getComponent()){
					POCDMT000040Component3.validateByModule(component, _location + "/component[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

    	}
    }

}